/**
 * @file
 * Required functions to configure Pirobox settings in entity types.
 */

(function ($) {
  Drupal.behaviors.formatterPirobox = {
    attach: function(context, settings) {
      // Realize multiple states if changed Gallery grouping
      // to 'No gallery' and handle the settings
      //   - Gallery covering
      //   - Gallery image random
      // @see file pirobox.module|pirobox_field_formatter_settings_form_get_element()
      $('.pirobox-gallery-grouping').change(function() {
        if($('.pirobox-gallery-grouping option:selected').val() == 'none') {
          // Handle gallery covering.
          $('.pirobox-gallery-covering').parent().hide();
          $('.pirobox-gallery-covering').val('0');
          // Handle gallery image random.
          $('.pirobox-gallery-random').parent().hide();
          $('.pirobox-gallery-random').attr('checked', false);
        }
        if($('.pirobox-gallery-grouping option:selected').val() != 'none') {
          // Handle gallery covering.
          $('.pirobox-gallery-covering').parent().show();
          // Handle gallery image random.
          $('.pirobox-gallery-random').parent().show();
        }
      });
    }
  };
})(jQuery);
